PGOBLIN_BANG(-f)
--# Copyright (C) @BABOLO  2007, 2008 http://www.babolo.ru/
--# All rights reserved.
--#
--# Redistribution and use in source and binary forms, with or without
--# modification, are permitted provided that the following conditions
--# are met:
--# 1. Redistributions of source code must retain the above copyright
--#    notice, this list of conditions and the following disclaimer.
--# 2. Redistributions in binary form must reproduce the above copyright
--#    notice, this list of conditions and the following disclaimer in the
--#    documentation and/or other materials provided with the distribution.
--#
--# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
--# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
--# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
--# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
--# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
--# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
--# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
--# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
--# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
--# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
--# SUCH DAMAGE.
--#
--# $Id: exchange.m4,v 1.3 2008/06/25 04:47:06 babolo Exp $

GETARG
#perform
CREATE TEMP TABLE x(plid int8, ftp int4);

INSERT INTO x(plid, ftp)
 SELECT (SELECT a::int8 FROM a WHERE i = 0 AND a ~ '^[0-9]+$' LIMIT 1), a::int4 FROM a
 WHERE i = 1 AND a ~ '^[0-9]+$'
;
DELETE FROM x WHERE (SELECT COUNT(*) FROM x) <> 1;
#select 2
SELECT '/usr/bin/find'
     , path || '/var/ftp'
     , '-type'
     , 'd'
     , '-depth'
     , '1'
 FROM x JOIN ftp USING(ftp)
;
#cat 00N
/dev/null
#exec 32N
#getstr 403
#copyin 004
CREATE TEMP TABLE u(i int4, u text);
COPY u FROM stdin;
#perform
UPDATE u SET u = substr(u, length(path || '/var/ftp') + 2) FROM x JOIN ftp USING(ftp);

DELETE FROM u
 WHERE u IN(SELECT nclient FROM x JOIN ftp USING(ftp) JOIN client USING(ftp) WHERE NOT super)
;
#select 2
      SELECT '/bin/rm', '-rf', path || '/var/ftp/' || u FROM u, x JOIN ftp USING(ftp)
#exec 02N

#select 2
      SELECT '/bin/mkdir'     , '-p'               , '/var' || path     FROM x JOIN ftp USING(ftp)
UNION SELECT '/bin/mkdir'     , '-p'               , path || '/var/ftp' FROM x JOIN ftp USING(ftp)
#exec 02N02
#wait 00002

#select 2
      SELECT '/bin/chmod'     , '755'              , path || '/var/ftp' FROM x JOIN ftp USING(ftp)
UNION SELECT '/usr/sbin/chown', suid || ':' || agrp, path || '/var/ftp' FROM x JOIN ftp USING(ftp)
#exec 02N02

#select 2
      SELECT '/bin/mkdir'     , '-p'                 , path || '/var/ftp/' || nclient || '/up'
       FROM x JOIN ftp USING(ftp) JOIN client USING(ftp)
       WHERE cena AND NOT super
UNION SELECT '/bin/mkdir'     , '-p'                 , path || '/var/ftp/' || nclient || '/down'
       FROM x JOIN ftp USING(ftp) JOIN client USING(ftp)
       WHERE cena AND NOT super
#exec 02N02
#wait 00002

#select 2
      SELECT '/bin/chmod'     , '755'                , path || '/var/ftp/' || nclient
       FROM x JOIN ftp USING(ftp) JOIN client USING(ftp)
       WHERE cena AND NOT super
UNION SELECT '/usr/sbin/chown',   suid || ':' || agrp, path || '/var/ftp/' || nclient
       FROM x JOIN ftp USING(ftp) JOIN client USING(ftp)
       WHERE cena AND NOT super
#exec 02N02
#wait 00002

#select 2
      SELECT '/bin/chmod'     , '-R', '775'                , path || '/var/ftp/' || nclient || '/up'
       FROM x JOIN ftp USING(ftp) JOIN client USING(ftp)
       WHERE cena AND NOT super
UNION SELECT '/bin/chmod'     , '-R', '775'                , path || '/var/ftp/' || nclient || '/down'
       FROM x JOIN ftp USING(ftp) JOIN client USING(ftp)
       WHERE cena AND NOT super
UNION SELECT '/usr/sbin/chown', '-R',   suid || ':' || agrp, path || '/var/ftp/' || nclient || '/down'
       FROM x JOIN ftp USING(ftp) JOIN client USING(ftp)
       WHERE cena AND NOT super
UNION SELECT '/usr/sbin/chown', '-R', client || ':' || agrp, path || '/var/ftp/' || nclient || '/up'
       FROM x JOIN ftp USING(ftp) JOIN client USING(ftp)
       WHERE cena AND NOT super
#exec 02N02
#wait 00002

#select 2
SELECT '/var' || path || '/group.new' FROM x JOIN ftp USING(ftp)
#file 32
#echo 3
wheel:*:0:
ftp:*:14:
www:*:80:
nogroup:*:65533:
nobody:*:65534:
#select 3
SELECT '
adm:*:' || agrp || ':
usr:*:' || ugrp || ':
'FROM x JOIN ftp USING(ftp)
#close 3

#select 2
SELECT '/var' || path || '/master.passwd' FROM x JOIN ftp USING(ftp)
#file 32
#select 4
SELECT '/var' || path || '/master.template' FROM x JOIN ftp USING(ftp)
#cat 34
#strselect 3
SELECT nclient
     , ':', cpass
     , ':', client
     , ':', CASE WHEN super THEN agrp ELSE ugrp END
     , '::0:0:', nclient
     , ':/var/ftp', CASE WHEN super THEN '' ELSE '/' || nclient END
     , ':/usr/libexec/false
'FROM x JOIN ftp USING(ftp) JOIN client USING(ftp)
 WHERE cena
#close 3

#select 2
SELECT '/var' || path || '/www.passwd.new' FROM x JOIN ftp USING(ftp)
#file 32
#strselect 3
SELECT nclient, ':', cpass, '
'FROM x JOIN ftp USING(ftp) JOIN client USING(ftp)
 WHERE cena
#close 3

#select 2
SELECT '/bin/mv', '-f', '/var' || path || '/group.new', '/var' || path || '/group'
 FROM x JOIN ftp USING(ftp)
#exec 02N02

#select 2
SELECT '/bin/mv', '-f', '/var' || path || '/www.passwd.new', '/var' || path || '/www.passwd'
 FROM x JOIN ftp USING(ftp)
#exec 02N02

#select 2
SELECT '/usr/sbin/pwd_mkdb', '-pd', '/var' || path, '/var' || path || '/master.passwd'
 FROM x JOIN ftp USING(ftp)
#exec 02N02
#wait 00002
